int sensorDerechoPin = 12;
int sensorIzquierdoPin = 11;

int in1 = 9;
int in2 = 8;
int in3 = 7;
int in4 = 6;

int ENA = 5;
int ENB = 3;

const int VELOCIDAD_MAXIMA = 100; // Máxima velocidad para avanzar en recta
const int VELOCIDAD_CURVA = 255;  // Máxima velocidad para la llanta que va en reversa durante la curva

const int tiempoRapido = 200; // Tiempo en milisegundos que avanzará a máxima velocidad.
const int tiempoLento = 500;  // Tiempo en milisegundos que irá lento o estará detenido para lectura.
unsigned long tiempoAnterior = 0;
bool modoRapido = true;

void setup() {
  pinMode(sensorDerechoPin, INPUT);
  pinMode(sensorIzquierdoPin, INPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(ENA, OUTPUT);
  pinMode(ENB, OUTPUT);
}

void loop() {
  unsigned long tiempoActual = millis();

  // Alternar entre modo rápido y lento basado en el tiempo
  if (modoRapido && tiempoActual - tiempoAnterior > tiempoRapido) {
    modoRapido = false;
    tiempoAnterior = tiempoActual;
  } 
  
  else if (!modoRapido && tiempoActual - tiempoAnterior > tiempoLento) {
    modoRapido = true;
    tiempoAnterior = tiempoActual;
  }
  int valorSensorDerecho = digitalRead(sensorDerechoPin);
  int valorSensorIzquierdo = digitalRead(sensorIzquierdoPin);

  if (valorSensorDerecho == HIGH && valorSensorIzquierdo == HIGH) {
    detenerCarrito();
  } else if (valorSensorDerecho == HIGH && valorSensorIzquierdo == LOW) {
    girarDerecha();
  } else if (valorSensorDerecho == LOW && valorSensorIzquierdo == HIGH) {
    girarIzquierda();
  } else {
    if (modoRapido) {
      irAdelanteMaximo();
    } else {
      irAdelante();
    }
  }
}

void detenerCarrito() {
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);
  analogWrite(ENA, 0);
  analogWrite(ENB, 0);
}

void irAdelante() {
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(ENA, VELOCIDAD_MAXIMA);
  analogWrite(ENB, VELOCIDAD_MAXIMA);
}

void irAdelanteMaximo() {
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(ENA, 255); // Velocidad máxima
  analogWrite(ENB, 255); // Velocidad máxima
}
void girarDerecha() {
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  analogWrite(ENB, VELOCIDAD_CURVA);
  analogWrite(ENA, VELOCIDAD_MAXIMA);
}

void girarIzquierda() {
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(ENB, VELOCIDAD_MAXIMA);
  analogWrite(ENA, VELOCIDAD_CURVA);
}
